/*
 * Copyright (c) 2002-3 Patrick Mochel
 * Copyright (c) 2002-3 Open Source Development Labs
 *
 * This file is released under the GPLv2
 */

#include <linux/device.h>
#include <linux/init.h>
#include <linux/memory.h>

#include "base.h"

/**
 * driver_init - initialize driver model.
 *
 * Call the driver model init functions to initialize their
 * subsystems. Called early from init/main.c.
 */
void __init driver_init(void)
{
	/* These are the core pieces */
   //printk("calling devtmpfs_init()\n");
	devtmpfs_init();
   //printk("calling devices_init()\n");
	devices_init();
   //printk("calling buses_init()\n");
	buses_init();
   //printk("calling classes_init()\n");
	classes_init();
   //printk("calling firmware_init()\n");
	firmware_init();
   //printk("calling hypervisor_init()\n");
	hypervisor_init();
   
	/* These are also core pieces, but must come after the
	 * core core pieces.
	 */
   // printk("calling platform_bus_init()\n");
	platform_bus_init();
   //printk("calling system_bus_init()\n");
	system_bus_init();
   //printk("calling cpu_dev_init()\n");
	cpu_dev_init();
   //printk("calling memory_dev_init()\n");
	memory_dev_init();
}
